<template>
    <div class="calendar border rounded p-2">
        <div class="calendar-header my-3">
            <div class="calendar-actions text-primary">
                <div class="h-100 d-flex align-items-center text-center" @click="previousMonth()">
                    <slot name="previous">&#12296;</slot>
                </div>
            </div>
            <div class="calendar-status">
                <h2 class="m-0">
                    {{ calendar.format('MMMM') }}
                </h2>
                <h2 class="m-0">
                    {{ calendar.format('Y') }}
                </h2>
            </div>
            <div class="calendar-actions text-primary">
                <div class="h-100 d-flex align-items-center" @click="nextMonth()">
                    <slot name="previous">&#12297;</slot>
                </div>
            </div>
        </div>

        <div class="calendar-weekdays pb-3 pt-4">
            <div v-for="(day, index) in weekDays" :key="index">
                <span><strong>{{day}}</strong></span>
            </div>
        </div>

        <div class="calendar-body">

            <div class="calendar-box" v-for="(date,i) in displayDates" :key="i">
                <div class="calendar-date rounded-circle p-2"
                     :class="{
                        'in-month': date.inMonth,
                        'selected': date.selected,
                        'has-event': events.includes(date.value.format('YYYY-MM-DD')),
                        'today': date.value.isSame(new Date(), 'day'),
                        }"
                     @click="selectDate(date.value)">
                    <span>{{ date.value.format('DD') }}</span>
                </div>
            </div>

        </div>

    </div>

</template>

<script>

    import moment from 'moment';

    export default {
        name: 'Calendar',
        props: {
            events: {
                type: Array,
                default: () => [],
            },
        },
        mounted: function () {
            this.emitSelectedDateEvent(this.selected);
        },
        computed: {
            weekDays: function () {
                return moment.weekdaysShort(true);
            },
            displayDates: function () {

                let startDay = this.calendar.clone();
                let endDay = this.calendar.clone().endOf('month');
                let weeks = this.getFullWeeksDifference(startDay, endDay) + 1;


                let beginDiff = startDay.day() - 1;
                let begin = startDay.clone().subtract(beginDiff, 'days');

                let totalDays = (weeks*7) - 1;

                let calView = [];

                for(let i = 0; i <= totalDays; i++) {
                    let date = begin.clone().add(i, 'days');
                    let dateObj = {
                        inMonth: (date.month() === this.calendar.month()),
                        selected: date.isSame(this.selected, 'day'),
                        value: date,
                    };
                    calView.push(dateObj);
                }


                return calView;
            }
        },
        data: function () {
            return {
                calendar: moment().startOf('month'),
                selected: moment(),
            }
        },
        methods: {
            previousMonth: function () {
                this.calendar = this.calendar.clone().subtract(1, 'month');
            },
            nextMonth: function() {
                this.calendar = this.calendar.clone().add(1, 'month');
            },
            selectDate: function(date) {

                this.selected = date;

                this.jumpToMonth(date);

                this.emitSelectedDateEvent(date);
            },
            jumpToMonth: function(date) {

                this.calendar = date.clone().startOf('month');

            },
            emitSelectedDateEvent: function (date) {
                let dateString = date.format('YYYY/MM/DD');
                this.$emit('dateSelected', dateString);
            },
            getFullWeeksDifference: function (start, end) {

                let startWeek = start.week();
                let endWeek = end.week();

                //Special December case
                if (endWeek < startWeek) {
                    // Set end week 1 plus max weeks
                    endWeek = 53;
                }

                return  endWeek - startWeek;

            },
        },
    }
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style lang="scss" scoped>

    @import "~bootstrap/scss/bootstrap.scss";

    .calendar {
        display: flex;
        flex-direction: column;
        font-family: 'Avenir', Helvetica, Arial, sans-serif;
        -webkit-font-smoothing: antialiased;
        -moz-osx-font-smoothing: grayscale;
        text-align: center;
        color: #2c3e50;

        .calendar-header {
            display: flex;
            flex-direction: row;
            justify-content: space-between;

            .calendar-actions {
                font-size: 2rem;

                &:hover {
                    cursor: pointer;
                }

            }

        }

        .calendar-weekdays {

            div {
                display: inline-block;
                width: (100% / 7);
            }

        }

        .calendar-body {

            .calendar-box::before {
                content: "";
                display: block;
                padding-top: 100%;
            }
            .calendar-box {
                position: relative;
                width: (100% / 7);
                display: inline-block;

                .calendar-date{
                    position: absolute;
                    margin: .25rem;
                    line-height:100%;
                    top: 0;

                    height: -webkit-calc(100% - .5rem);
                    height: -moz-calc(100% - .5rem);
                    height: calc(100% - .5rem);

                    width: -webkit-calc(100% - .5rem);
                    width: -moz-calc(100% - .5rem);
                    width: calc(100% - .5rem);

                    text-align: center;
                    display: flex;
                    align-items: center;
                    justify-content: center;
                    color: #aaa;

                    &.today {
                        background-color: #cce5ff;
                    }

                    &.in-month {
                        color: black;
                    }
                    &.selected {
                        background-color: $primary;
                        color: $light;
                    }
                    &.has-event {
                        border: 1px solid $primary;
                    }
                    &:hover {
                        background-color: lighten($primary, 15%);
                        cursor: pointer;
                    }
                    &.selected:hover{
                        background-color: $primary;
                    }
                }
            }
        }

    }
</style>
